package lightcontainer.domains.client;

import java.util.HashMap;
import java.util.Map;

public class RequestBundle {

    private Map<String, String> stringData = new HashMap<>();

    private Map<String, Integer> intData = new HashMap<>();

    /**
     * Permet d'ajouter des String
     * @param key La clé permettant de retrouver la valeur
     * @param value La valeur associée à la clé
     */
    public void putString(String key, String value) {
        stringData.put(key, value);
    }

    /**
     * Permet d'ajouter des int
     * @param key La clé permettant de retrouver la valeur
     * @param value La valeur associée à la clé
     */
    public void putInt(String key, int value) {
        intData.put(key, value);
    }

    /**
     * Permet de récupérer des données string
     * @param key La clé permettant de retrouver la valeur
     * @return La valeur associée à la clé ou null
     */
    public String getString(String key) {
        return stringData.get(key);
    }

    /**
     * Permet de récupérer des données int
     * @param key La clé permettant de retrouver la valeur
     * @return La valeur associée à la clé
     */
    public int getInt(String key) {
        return intData.get(key);
    }
}
