package lightcontainer.protocol.rules.reader;

import lightcontainer.domains.client.Context;
import lightcontainer.interfaces.ProtocolRepository;
import lightcontainer.protocol.ProtocolReader;
import lightcontainer.protocol.rules.writer.GetFileErrorRule;

public class RetrieveErrorRule extends ProtocolReader {
    // Constants
    private static final String PATTERN = "^RETRIEVE_ERROR\r\n$";
    private static final String NAME = "RETRIEVE_ERROR";

    // Variables
    private final ProtocolRepository protocolRep;

    // Constructor
    public RetrieveErrorRule(ProtocolRepository protocolRep) {
        super(NAME, PATTERN);
        this.protocolRep = protocolRep;
    }

    /**
     * Cette méthode est appelée lors de l'exécution de la règle
     *
     * @param context Utilisateur context.
     * @param data    Paramètres pour créer la commande.
     */
    @Override
    protected ProtocolReader.ProtocolResult onExecuted(Context context, String... data) {
        ProtocolReader.ProtocolResult result = new ProtocolReader.ProtocolResult(context);
        result.setResultCommand(protocolRep.executeWriter(context, GetFileErrorRule.NAME), ResultCmdReceiver.CLIENT);
        return result;
    }
}
