package lightcontainer.utils;

import java.io.*;

public class FileSender {
    private static final int DEFAULT_BUFFER=8000;
    private final String path;

    public FileSender(String path) { this.path = path; }

    public boolean sendFile(String filename, OutputStream out, int fileSize, String aesKey, String iv) throws IOException {
        BufferedInputStream bisFile;
        System.out.printf("Envoie fichier :  %s - %s - %s \n", filename, aesKey, iv);
        try {
            File f = new File(String.format("%s/%s", path, filename));
            if(f.exists()) {
                bisFile = new BufferedInputStream(new FileInputStream(f));

                AES_GCM.decryptStream(bisFile, out, fileSize, aesKey, iv);

                bisFile.close();
                return true;
            } else
                return false;
        } catch(IOException | AES_GCM.AesGcmException ex) {
            throw new IOException();
        }
    }

    public boolean sendFile(String filename, OutputStream out) throws IOException {
        BufferedInputStream bisFile;
        int bytesReaded = 0;

        try {
            File f = new File(String.format("%s/%s", path, filename));
            long fileSize = f.length();
            if(f.exists()) {
                byte[] buffer = new byte[DEFAULT_BUFFER];
                bisFile = new BufferedInputStream(new FileInputStream(f));
                long currentOffset = 0;
                while((currentOffset < fileSize) && (bytesReaded = bisFile.read(buffer)) > 0) {
                    out.write(buffer, 0, bytesReaded); out.flush();
                    currentOffset+= bytesReaded;
                }
                bisFile.close();
                return true;
            } else
                return false;
        } catch(IOException ex) {
            throw ex;
        }
    }

}